/* 
	PlayStation system call by BERO
	this source must compile -O2
*/

#ifdef PSX

#include	"syscall.h"

#define	SYSCALL(sys,no)	asm("li $8,%0;.set noreorder;.set nomacro;j $8; li $9,%1;.set macro;.set reorder" : : "i"(sys),"i"(no) : "$8","$9")

void InitHeap(long *ptr,long size) { SYSCALL(0xa0,0x39); }
malloc() {SYSCALL(0xa0,0x33);}
free() {SYSCALL(0xa0,0x34);}
calloc() {SYSCALL(0xa0,0x37);}
realloc() {SYSCALL(0xa0,0x38);}

void EnterCriticalSection(void)
{
	asm(".set noreorder;.set nomacro;li $4,1; syscall;.set macro;.set reorder" :::"$4");
}

void ExitCriticalSection(void)
{
	asm(".set noreorder;.set nomacro;li $4,2; syscall;.set macro;.set reorder" :::"$4");
}

bcopy() {SYSCALL(0xa0,0x27);}
memcpy() {SYSCALL(0xa0,0x2a);}
memset() {SYSCALL(0xa0,0x2b);}
strcpy() {SYSCALL(0xa0,0x19);}
puts() {SYSCALL(0xa0,0x3e);}
printf() {SYSCALL(0xa0,0x3f);}

long InitPAD(char *buf1,long size1,char *buf2,long size2)
{
	SYSCALL(0xb0,0x12);
}

long StartPAD(void) {SYSCALL(0xb0,0x13);}
void StopPAD(void) {SYSCALL(0xb0,0x14);}

void SetGPUStatus(long data) { SYSCALL(0xa0,0x48); }
void GPU_cw(long cw) {SYSCALL(0xa0,0x49);}
void GPU_cwb(long *pdata,long n) {SYSCALL(0xa0,0x4a);}
int GetGPUStatus(void) {SYSCALL(0xa0,0x4d);}

open()	{SYSCALL(0xa0,0x00);}
lseek()	{SYSCALL(0xa0,0x01);}
read()	{SYSCALL(0xa0,0x02);}
write()	{SYSCALL(0xa0,0x03);}
close()	{SYSCALL(0xa0,0x04);}

#endif