#ifndef _GPU_COM_H
#define	_GPU_COM_H
#define	GPU_RESET_ALL	0x00
#define	GPU_RESET_COM	0x01
#define	GPU_RESET_IRQ	0x02
#define	GPU_DISP_MASK	0x03
#define	GPU_IOMODE	0x04
#define	GPU_HORIZONAL	0x06
#define	GPU_VERTICAL	0x07
#define	GPU_DISP_MODE	0x08
#define	GPU_DISP_OFFSET	0x05
#define	GPU_TPAGE	0xe1
#define	GPU_TWIN	0xe2
#define	GPU_CLIP_START	0xe3
#define	GPU_CLIP_END	0xe4
#define	GPU_DRAW_OFFSET	0xe5
#define	GPU_PRIORITY	0xe6
#define	GPU_BOXF	0x02
#define	GPU_F3	0x20
#define	GPU_FT3	0x24
#define	GPU_F4	0x28
#define	GPU_FT4	0x2c
#define	GPU_G3	0x30
#define	GPU_GT3	0x34
#define	GPU_G4	0x38
#define	GPU_GT4	0x3c
#define	GPU_LINEF2	0x40
#define	GPU_LINEF3	0x48
#define	GPU_LINEF4	0x4c
#define	GPU_LINEG2	0x50
#define	GPU_LINEG3	0x58
#define	GPU_LINEG4	0x5c
#define	GPU_TILE	0x60
#define	GPU_SPRT	0x64
#define	GPU_TILE1	0x68
#define	GPU_TILE8	0x70
#define	GPU_SPRT8	0x74
#define	GPU_TILE16	0x78
#define	GPU_SPRT16	0x7c
#define	GPU_MOVE	0x80
#define	GPU_LOAD	0xa0
#define	GPU_STORE	0xc0
#define	NOSHADE	1
#define	H_REV	(1<<12)
#define	V_REV	(1<<13)
#endif